org.springframework.context.annotation

## Enum FilterType

- java.lang.Object
- - java.lang.Enum<FilterType>
  - - org.springframework.context.annotation.FilterType

All Implemented Interfaces:
  Serializable, Comparable<FilterType>

    public enum FilterType
    extends Enum<FilterType>

Enumeration of the type filters that may be used in conjunction with `@ComponentScan`.

Since:
  2.5
Author:
  Mark Fisher, Juergen Hoeller, Chris Beams
See Also:
  `ComponentScan`, `ComponentScan.includeFilters()`, `ComponentScan.excludeFilters()`, `TypeFilter`

### Enum Constant Summary

Enum Constants
Enum Constant and Description
`ANNOTATION` Filter candidates marked with a given annotation.
`ASSIGNABLE_TYPE` Filter candidates assignable to a given type.
`CUSTOM` Filter candidates using a given custom `TypeFilter` implementation

### Method Summary

Methods
`static FilterType` `valueOf(String name)` Returns the enum constant of this type with the specified name.
`static FilterType[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### ANNOTATION

    public static final FilterType ANNOTATION

Filter candidates marked with a given annotation.

See Also:
  `AnnotationTypeFilter`

#### ASSIGNABLE_TYPE

    public static final FilterType ASSIGNABLE_TYPE

Filter candidates assignable to a given type.

See Also:
  `AssignableTypeFilter`

#### CUSTOM

    public static final FilterType CUSTOM

Filter candidates using a given custom `TypeFilter` implementation

### Method Detail

#### values

    public static FilterType[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (FilterType c : FilterType.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static FilterType valueOf(String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null